#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <paths.h>
#include <time.h>
#include <protocols/rwhod.h>

void main(int argc, char *argv[])
{
	struct	whod	rwho;
	int	fd;
	int	size;
	char	tmp[80];

	sprintf(tmp,_PATH_RWHODIR "/whod.%s", argv[1]);
	fd = open(tmp, O_RDONLY);
	if (fd<0) {
		perror(tmp);
		exit(1);
	}
	size = read(fd,&rwho,sizeof(rwho));
	close(fd);
	printf( "vers    : %d\n"
		"type    : %d\n"
		"sendtime: %s",
			rwho.wd_vers,
			rwho.wd_type,
			ctime(&rwho.wd_sendtime));
	printf( "recvtime: %s"
		"hostname: %s\n"
		"loadavg : %d %d %d\n",
			ctime(&rwho.wd_recvtime),
			rwho.wd_hostname,
			rwho.wd_loadav[0],
			rwho.wd_loadav[1],
			rwho.wd_loadav[2]);
	printf( "boottime: %s"
		"====================================\n",
			ctime(&rwho.wd_boottime));
	for (fd=0; size>60; fd++, size -= sizeof(struct whoent)) {
		struct whoent *pw = &rwho.wd_we[fd];
		char *p = ctime(&pw->we_utmp.out_time);
		*strchr(p,'\n') = '\0';

		printf("%d: %-8.8s %-8.8s %s %d\n",
			fd,
			pw->we_utmp.out_line,
			pw->we_utmp.out_name,
			p,
			pw->we_idle);
	}
}
